package com.ejie.ab79.model.preguntasRespuestas;

import java.util.Date;
import java.util.List;

import com.ejie.ab79.model.inspecciones.Inspecciones;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * RespuestasProtocolo  
 * 
 *  
 */

public class RespuestasProtocolo implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idRespuestaProtocolo;
	private Integer idRelProPre;
	private Inspecciones inspeccion;
	private String respuesta;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private List<FicherosAdjPro> ficherosAdjPro;

	/**
	 * Method 'RespuestasProtocolo'.
	 */
	public RespuestasProtocolo() {
	}

	/**
	 * Method 'RespuestasProtocolo'.
	 * 
	 * @param idRespuestaProtocolo
	 *            Integer
	 */
	public RespuestasProtocolo(Integer idRespuestaProtocolo) {
		this.idRespuestaProtocolo = idRespuestaProtocolo;
	}

	/**
	 * Method 'RespuestasProtocolo'.
	 * 
	 * @param idRespuestaProtocolo
	 *            Integer
	 * @param idPreguntaProtocolo
	 *            Integer
	 * @param inspeccion
	 *            Inspecciones
	 * @param respuesta
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 */
	public RespuestasProtocolo(Integer idRespuestaProtocolo, Integer idRelProPre, Inspecciones inspeccion,
			String respuesta, Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion,
			String usuarioUltmodificacion) {

		this.idRespuestaProtocolo = idRespuestaProtocolo;
		this.idRelProPre = idRelProPre;
		this.inspeccion = inspeccion;
		this.respuesta = respuesta;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getIdRespuestaProtocolo'.
	 *
	 * @return Integer
	 */

	public Integer getIdRespuestaProtocolo() {
		return this.idRespuestaProtocolo;
	}

	/**
	 * Method 'setIdRespuestaProtocolo'.
	 *
	 * @param idRespuestaProtocolo
	 *            Integer
	 * @return
	 */

	public void setIdRespuestaProtocolo(Integer idRespuestaProtocolo) {
		this.idRespuestaProtocolo = idRespuestaProtocolo;
	}

	/**
	 * Method 'getIdRelProPre'.
	 *
	 * @return Integer
	 */

	public Integer getIdRelProPre() {
		return this.idRelProPre;
	}

	/**
	 * Method 'setIdRelProPre'.
	 *
	 * @param idRelProPre
	 *            Integer
	 * @return
	 */

	public void setIdRelProPre(Integer idRelProPre) {
		this.idRelProPre = idRelProPre;
	}

	/**
	 * Method 'getInspeccion'.
	 *
	 * @return Inspecciones
	 */

	public Inspecciones getInspeccion() {
		return this.inspeccion;
	}

	/**
	 * Method 'setInspeccion'.
	 *
	 * @param inspeccion
	 *            Inspecciones
	 * @return
	 */

	public void setInspeccion(Inspecciones inspeccion) {
		this.inspeccion = inspeccion;
	}

	/**
	 * Method 'getRespuesta'.
	 *
	 * @return String
	 */

	public String getRespuesta() {
		return this.respuesta;
	}

	/**
	 * Method 'setRespuesta'.
	 *
	 * @param respuesta
	 *            String
	 * @return
	 */

	public void setRespuesta(String respuesta) {
		this.respuesta = respuesta;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getFicherosAdjPro'.
	 *
	 * @return List<FicherosAdjPro>
	 */

	public List<FicherosAdjPro> getFicherosAdjPro() {
		return ficherosAdjPro;
	}

	/**
	 * Method 'setFicherosAdjPro'.
	 *
	 * @param ficherosAdjPro
	 *            List<FicherosAdjPro>
	 * @return
	 */

	public void setFicherosAdjPro(List<FicherosAdjPro> ficherosAdjPro) {
		this.ficherosAdjPro = ficherosAdjPro;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idRespuestaProtocolo: ").append(this.idRespuestaProtocolo).append(" ]");
		result.append(", [ idRelProPre: ").append(this.idRelProPre).append(" ]");
		result.append(", [ idInspeccion: ").append(this.inspeccion != null ? this.inspeccion.getIdInspeccion() : null)
				.append(" ]");
		result.append(", [ respuesta: ").append(this.respuesta).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

}
